local slotFrame = {
	[0] = "HeadSlot",
	[1] = "HandsSlot",
	[2] = "FeetSlot",
	[3] = "ChestSlot",
	[4] = "LegsSlot",
	[5] = "BackSlot",
	[6] = "WaistSlot",
	[7] = "ShoulderSlot",
	[8] = "NecklaceSlot",
	[9] = "AmmoSlot",
	[10] = "RangedSlot",
	[11] = "Ring0Slot",
	[12] = "Ring1Slot",
	[13] = "Earring0Slot",
	[14] = "Earring1Slot",
	[15] = "MainHandSlot",
	[16] = "SecondaryHandSlot"
	};
	
function ItemDurableString_OnLoad(this)
	this:RegisterEvent("PLAYER_INVENTORY_CHANGED");
	this:RegisterEvent("VARIABLES_LOADED");
	ItemDurableStringUpdate(this);
end

function ItemDurableString_OnEvent(this, event)
	if (event == "PLAYER_INVENTORY_CHANGED") then
		ItemDurableStringUpdate(this);		
	elseif (event == "VARIABLES_LOADED") then
		ItemDurableStringUpdate(this);
	end
end

function ItemDurableStringUpdate(this)
	local id = this:GetID();
	local iconPath = getglobal(this:GetName().."Icon");
	local itemName = getglobal(this:GetName().."Name");
	local durable = getglobal(this:GetName().."Durable");
	
	local textureName = GetInventoryItemTexture("player", id);
	local slotId, baseTexture = GetInventorySlotInfo(slotFrame[id]);
	if (textureName) then
		iconPath:SetTexture(textureName);
	else
		iconPath:SetTexture(baseTexture);
	end
	
	local durableValue, durableMax, name = GetInventoryItemDurable("player", slotId);
	local par = durableValue / durableMax * 100;
	local quality = GetInventoryItemQuality("player", slotId);
	if (name) then
		itemName:SetText(name);
		durable:SetText(durableValue.." / "..durableMax.." ("..math.floor(par).."%)");
		if (quality > 0) then
			itemName:SetColor(GetItemQualityColor(quality));
		else
			itemName:SetColor(1, 1, 1);
		end
	else
		itemName:SetText(SUI_NOT_EQUIPED);
		itemName:SetColor(.5, .5, .5);
		durable:SetText("");
	end
	ItemDurable_SetColor(durable, par)
end

function ItemDurable_SetColor(durable, par)
	local p=par/100;
	
	if (par<=-1) then
		durable:SetColor(0.2, 0.2, 0.2);	
	elseif (par>=0 and par<30) then
		p=(p)*(100/30);	
		durable:SetColor(1, p, 0);	
	elseif (par>=30 and par<50) then
		p=(p-0.3)*(100/20);
		durable:SetColor(1, 0.5+p, 0);	
	elseif (par>=50 and par<100) then
		durable:SetColor(1, p, p);	
	else
		durable:SetColor(0, 1, 0);	
	end
end