EXPERIENCE_EXTRA_VALUE = 0;
SKILLPOINT_EXTRA_VALUE = 0;

function SUI_ExperienceFrame_OnLoad(this)
	this:RegisterEvent("LOADING_END");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_EXP_CHANGED");
	this:RegisterEvent("TP_EXP_UPDATE");
	SUI_ExperienceStatusBar_Update();
	--SUI_BagFrameMoneyCoinButtonText:SetColor(1, 1, 0);
end

function SUI_ExperienceFrame_OnEvent(this, event, arg1, arg2)
	if (event == "LOADING_END") then
		ExperienceFrame:UnregisterEvent("PLAYER_EXP_CHANGED");
		ExperienceFrame:Hide();
	end
	if (event == "PLAYER_EXP_CHANGED") or (event == "TP_EXP_UPDATE") then
		SUI_ExperienceStatusBar_Update();
	end
	if (event == "PLAYER_EXP_CHANGED") or (event == "LOADING_END") then
		SUI_ExperienceDebt_Update();
	end
end

function SUI_ExperienceStatusBar_Update()
	local maxExp = GetPlayerMaxExp();
	local currExp = GetPlayerExp();
	local tPoint = GetTpExp();
	
	SUI_ExperienceStatusBar:SetMaxValue(maxExp);
	SUI_ExperienceStatusBar:SetValue(currExp);
	SUI_ExperienceText:SetText(SUI_Value(currExp).." / "..SUI_Value(maxExp).." ("..(math.floor(currExp/maxExp*100)).."%)   "..SUI_Value(tPoint).." "..SKILLBOOK_TP);
	
	local offset = -8;
	if (maxExp ~= 0) then
		offset = offset + SUI_ExperienceStatusBar:GetWidth() * currExp / maxExp;
	end
	SUI_ExperienceHeadTexture:ClearAllAnchors();
	SUI_ExperienceHeadTexture:SetAnchor("LEFT", "LEFT", "SUI_ExperienceStatusBar", offset, 0);

	local exp, tp = GetPlayerExtraPoint();
	if ( exp > 0 ) then
		local value = exp + currExp;
		if (value > maxExp) then
			value = maxExp;
		end
		EXPERIENCE_EXTRA_VALUE = -8 + SUI_ExperienceStatusBar:GetWidth() * value / maxExp;
		SUI_ExtraExperienceFrame:ClearAllAnchors();
		SUI_ExtraExperienceFrame:SetAnchor("LEFT", "LEFT", "SUI_ExperienceStatusBar", EXPERIENCE_EXTRA_VALUE, 0);
		SUI_ExtraExperienceFrame:Show();
	else
		SUI_ExtraExperienceFrame:Hide();
	end

	if ( tp > 0 ) then
		local value = tp * 10 + currExp;
		if (value > maxExp) then
			value = maxExp;
		end
		SKILLPOINT_EXTRA_VALUE = -8 + SUI_ExperienceStatusBar:GetWidth() * value / maxExp;
		SUI_ExtraSkillPointFrame:ClearAllAnchors();
		SUI_ExtraSkillPointFrame:SetAnchor("LEFT", "LEFT", "fExperienceStatusBar", SKILLPOINT_EXTRA_VALUE, 0);
		SUI_ExtraSkillPointFrame:Show();
	else
		SUI_ExtraSkillPointFrame:Hide();
	end
end

function SUI_PlayerExtraTips_Show(this, type)
	local exp, tp = GetPlayerExtraPoint();
	local text = TEXT("EXTRA_POINT_TIP");
	local all = nil;
	
	if (math.abs(EXPERIENCE_EXTRA_VALUE - SKILLPOINT_EXTRA_VALUE) < 16) then
		all = 1;
	end

	GameTooltip:SetOwner(this, "ANCHOR_TOP");
	if (all or (type == "EXP")) then
		text = text.."\n".."EXP + "..exp;
	end
	if (all or (type == "TP")) then
		text = text.."\n".."TP + "..tp;
	end	
	GameTooltip:SetText(text);
end

function SUI_ExperienceDebt_Update()
	local textExp;
	local textTP;
	local mainExp, mainTp, subExp, subTp = GetPlayerExpDebt();
	textExp = SUI_Value(mainExp);
	if subExp and subExp < 0 then
		textExp = SUI_Value(mainExp).."("..SUI_Value(subExp)..")";
	end
	textTP = SUI_Value(mainTp);
	if subTp and subTp < 0 then
		textTP = SUI_Value(mainTp).."("..SUI_Value(subTp)..")";
	end
	if mainExp < 0 or mainTp < 0 then
		SUI_ExperienceDebtText:SetColor(1, 0.25, 0);
		SUI_ExperienceDebtText:SetText(textExp.." / "..textTP);
	else
		SUI_ExperienceDebtText:SetText("");
	end
end

function SUI_ExperienceDebt_OnEnter(this)
	local text;
	local mainExp, mainTp, subExp, subTp = GetPlayerExpDebt();
	
	GameTooltip:SetOwner(this, "ANCHOR_TOP", 0, -2);
	GameTooltip:SetText(DEBT_EXPERIENCE_TIPS_TITLE);
	text = DEBT_EXP.. mainExp;
	if ( subExp ) then
		text = text.."("..subExp..")";
	end
	GameTooltip:AddLine(text, 0, 1, 0);
	text = DEBT_TP..mainTp;
	if ( subTp ) then
		text = text.."("..subTp..")";
	end
	GameTooltip:AddLine(text, 0, 1, 0);
	GameTooltip:AddLine(DEBT_EXPERIENCE_TIPS, 1, 1, 1);
	GameTooltip:Show();
end