function SUI_MinimapFrame_OnLoad(this)
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("LOADING_END");
	this:RegisterEvent("ZONE_CHANGED");
	this:RegisterEvent("UPDATE_PARALLEL");
	this:RegisterEvent("SWAP_EQUIPMENT_SUCCESS");
	SUI_minimapUpdateTime = 5
	
end

function SUI_MinimapFrame_OnEvent(this, event)
	if (event == "LOADING_END") then
		MinimapFrameBorder:Hide();
		MinimapRimFrame:Hide();
		MinimapDisableFrame:Hide();
		MinimapFrameRestoreUIButton:Hide();
		MinimapFrameTime:Hide();
		MinimapFramePlusButton:Hide();
		MinimapFrameMinusButton:Hide();
		MinimapFramePlayerPosition:Hide();
		
		MinimapFrameBulletinButton:SetSize(20, 20);
		MinimapNpcTrackButton:SetSize(20, 20);
		MinimapFrameBattleGroundButton:SetSize(20, 20);
		MinimapFrameOptionButton:SetSize(20, 20);
		MinimapFrameQuestTrackButton:SetSize(20, 20);
		MinimapFrameStoreButton:SetSize(20, 20);
		MinimapBeautyStudioButton:SetSize(20, 20);
		
		ClearSetAnchor(MinimapFrameBulletinButton, "TOPRIGHT", "TOPLEFT", SUI_MinimapViewBorder, 0, 21);
		ClearSetAnchor(MinimapNpcTrackButton, "TOP", "BOTTOM", MinimapFrameBulletinButton, 0, 0);
		ClearSetAnchor(MinimapFrameBattleGroundButton, "TOP", "BOTTOM", MinimapNpcTrackButton, 0, 0);
		ClearSetAnchor(MinimapFrameOptionButton, "TOP", "BOTTOM", MinimapFrameBattleGroundButton, 0, 0);
		ClearSetAnchor(MinimapFrameQuestTrackButton, "TOP", "BOTTOM", MinimapFrameOptionButton, 0, 0);
		ClearSetAnchor(MinimapFrameStoreButton, "TOP", "BOTTOM", MinimapFrameQuestTrackButton, 0, 0);
		ClearSetAnchor(MinimapBeautyStudioButton, "TOP", "BOTTOM", MinimapFrameStoreButton, 0, 0);
			
		ClearSetAnchor(MinimapViewFrame, "TOPRIGHT", "BOTTOMRIGHT", SUI_MinimapBorder, -3, 3);
		ClearSetAnchor(FramerateText, "TOPLEFT", "TOPLEFT", UIParent, 0, 0);
		
		MinimapViewFrame:SetSize(154, 154);
	end
	if (event == "LOADING_END" or event == "UPDATE_PARALLEL") then
		SUI_PlayerParallelFrameText:SetText(GetCurrentParallelID());
	end
	if (event == "LOADING_END" or event == "SWAP_EQUIPMENT_SUCCESS") then
		SUI_SwapEquipFrameText:SetText(GetEuipmentNumber());
	end
	SUI_MinimapMask_Update();
end

function SUI_WorldMapButton_OnClick(this, key)
	if (not IsShiftKeyDown()) then
		ToggleUIFrame(UI_WorldMapFrame);
	else
		local SW, SH = MinimapViewFrame:GetSize();
		if (SW == 154) then
			MinimapViewFrame:SetSize(234, 234);
			SUI_MinimapViewBorder:SetSize(240, 240);
			MINIMAPFRAME_MASK_NAME = "interface/common/block-fill";
		else
			MinimapViewFrame:SetSize(154, 154);
			SUI_MinimapViewBorder:SetSize(160, 160);
			MINIMAPFRAME_MASK_NAME = "interface/common/block-fill";
		end
	end	
end

function SUI_MinimapMask_Update()
	OnLoad_Lua_Minimap(MinimapFrame);
	MINIMAPFRAME_MASK_NAME = "interface/common/block-fill";
	SUI_BorderZoneName:SetText(GetZoneName());
end

function SUI_GameTimeFrame_OnUpdate(this, elapsedTime)
	SUI_minimapUpdateTime = SUI_minimapUpdateTime - elapsedTime;
	if (SUI_minimapUpdateTime <= 0) then
		SUI_minimapUpdateTime = 5;
		local gametime = GetCurrentGameTime();
		local strTime = nil; 
		if( gametime < 30 ) then
			strTime = UI_MINIMAP_TIME_MORNING;
		elseif( gametime < 120 ) then
			strTime = UI_MINIMAP_TIME_DAYTIME;
		elseif( gametime < 150 ) then
			strTime = UI_MINIMAP_TIME_DUSK;
		else
			strTime = UI_MINIMAP_TIME_NIGHT;
		end
		SUI_GameTimeFrameText:SetText(strTime);
	end
end

function SUI_RealTimeFrame_OnUpdate(this, elapsedTime)
	SUI_RealTimeFrameText:SetText(os.date("%H:%M"))
end

function SUI_PlayerPositionFrame_Update(elapsedTime)
	local x, y = GetPlayerWorldMapPos();
	if (x and y) then
		local s = string.format( "%.1f : %.1f" , x * 100 , y * 100 );
		SUI_PlayerPositionFrameText:SetText(s);
	else
		SUI_PlayerPositionFrameText:SetText("");
	end
end
	
function ClearSetAnchor(frame,point,relativePoint,relativeTo,x,y)
	frame:ClearAllAnchors();
	frame:SetAnchor(point,relativePoint,relativeTo,x,y);
end

function SUI_AmmoFrame_OnLoad(this)
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_INVENTORY_CHANGED");
end

function SUI_AmmoFrame_OnEvent(this, event)
	local ammoCount = getglobal(this:GetName().."Text")
	local count = GetInventoryItemCount("player", 9)
	if count then
		if count >= 100 then
			ammoCount:SetColor(1, 1, 0)
		else
			ammoCount:SetColor(1, 0.5, 0)
		end
		ammoCount:SetText(count)
	else
		ammoCount:SetText("")
	end
end